//
// C++ Interface: %{MODULE}
//
// Description: AutotimerMenu
//
//
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef MENU_H
#define MENU_H

#include <mysql/mysql.h>
#include <vdr/menu.h>
#include <vdr/interface.h>
#include "autotimer.h"
#include "libmysqlwrapped.h"

/**
@author Ralf Dotzert
*/

class cXxvAutotimerEdit : public cOsdMenu
{
private:
   cXxvAutoTimer *_timer;

public:
    cXxvAutotimerEdit(cXxvAutoTimer *timer);
    ~cXxvAutotimerEdit();
    void  Set();
    eOSState ProcessKey(eKeys Key);
};


class cXxvAutotimerMenu : public cOsdMenu
{
private:
    enum          State { UNDEF, EDIT, NEW, DELETE};
    State         _state;

    Database      *_db;
    cXxvAutoTimers _timers;
    bool           getTimers();
    cXxvAutoTimer  _currTimer;
    void           updateTimer();
    void           insertTimer();
    void           deleteTimer();


public:
    cXxvAutotimerMenu();
    ~cXxvAutotimerMenu();
    void  Set();
    eOSState ProcessKey(eKeys Key);
};

#endif
