//
// C++ Implementation:
//
// Description: Setup of Autotimer
//
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "setup.h"


static const char allowed[] = { " abcdefghijklmnopqrstuvwxyz0123456789-_/" };
static const char *strHost           = "Host";
static const char *strDatabase       = "Database";
static const char *strDatabasePort   = "Database-Port";
static const char *strDatabaseUser   = "Database-User";
static const char *strDatabasePasswd = "Database-Password";
static const char *strLifetime = "Default-Lifetime";
static const char *strPriority = "Default-Priority";
static const char *strXXV020   = "XXV Version < 0.30";


cXxvAutotimerSetup::cXxvAutotimerSetup()
{
  strcpy(host, "localhost");
  strcpy(database, "xxv");
  strcpy(user,"root");
  strcpy(passwd,"");
  dbPort = 3304;
  defaultLifetime = 50;
  defaultPriority = 50;
  xxv020 = false;
}

bool cXxvAutotimerSetup::SetupParse( const char * Name, const char * Value )
{
    if      (strcmp(Name, strDatabase )       == 0) snprintf(database, sizeof(database), Value);
    else if (strcmp(Name, strHost )           == 0) snprintf(host, sizeof(host), Value);
    else if (strcmp(Name, strDatabasePort )   == 0) dbPort   = atoi(Value);
    else if (strcmp(Name, strDatabaseUser )   == 0) snprintf(user, sizeof(user), Value);
    else if (strcmp(Name, strDatabasePasswd ) == 0) snprintf(passwd, sizeof(passwd), Value);
    else if (strcmp(Name, strLifetime )       == 0) defaultLifetime   = atoi(Value);
    else if (strcmp(Name, strPriority )       == 0) defaultPriority   = atoi(Value);
    else if (strcmp(Name, strXXV020 )         == 0) xxv020   = atoi(Value);
    else return false;

    return true;
}
//--------------------------------------------------------------


cXxvAutotimerSetupPage::cXxvAutotimerSetupPage( void )
{
   Add(new cMenuEditBoolItem(tr(strXXV020),       &autotimerSetup.xxv020));
   Add(new cMenuEditStrItem(tr(strHost),          autotimerSetup.host, sizeof(autotimerSetup.host) + 1, allowed));
   Add(new cMenuEditStrItem(tr(strDatabase),      autotimerSetup.database, sizeof(autotimerSetup.database) + 1, allowed));
   Add(new cMenuEditIntItem(tr(strDatabasePort),  &autotimerSetup.dbPort,1,9999));
   Add(new cMenuEditStrItem(tr(strDatabaseUser),  autotimerSetup.user, sizeof(autotimerSetup.user) + 1, allowed));
   Add(new cMenuEditStrItem(tr(strDatabasePasswd),autotimerSetup.passwd, sizeof(autotimerSetup.passwd) + 1, allowed));
   Add(new cMenuEditIntItem(tr(strLifetime),      &autotimerSetup.defaultLifetime,1,MAXLIFETIME));
   Add(new cMenuEditIntItem(tr(strPriority),      &autotimerSetup.defaultPriority,1,MAXPRIORITY));
  
}


void cXxvAutotimerSetupPage::Store( void )
{
  SetupStore(strHost,         autotimerSetup.host);
  SetupStore(strDatabase,     autotimerSetup.database);
  SetupStore(strDatabasePort, autotimerSetup.dbPort);
  SetupStore(strDatabaseUser, autotimerSetup.user);
  SetupStore(strDatabasePasswd, autotimerSetup.passwd);
  SetupStore(strLifetime,       autotimerSetup.defaultLifetime);
  SetupStore(strPriority,       autotimerSetup.defaultPriority);
  SetupStore(strXXV020,         autotimerSetup.xxv020);
}

