/*
 * xxvautotimer.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id: xxvautotimer.cpp,v 1.4 2005/04/22 22:47:53 ralf Exp $
 */

#include <vdr/plugin.h>
#include "setup.h"
#include "menu.h"
#include "i18n.h"

static const char *VERSION        = "0.0.6";
static const char *DESCRIPTION    = "Edit XXV Autotimers";
static const char *MAINMENUENTRY  = "Autotimer for XXV";

class cPluginXxvautotimer : public cPlugin {
private:
  // Add any member variables or functions you may need here.
public:
  cPluginXxvautotimer(void);
  virtual ~cPluginXxvautotimer();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return tr(DESCRIPTION); }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Initialize(void);
  virtual bool Start(void);
  virtual void Stop(void);
  virtual void Housekeeping(void);
  virtual const char *MainMenuEntry(void) { return tr(MAINMENUENTRY); }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
  };

cPluginXxvautotimer::cPluginXxvautotimer(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}

cPluginXxvautotimer::~cPluginXxvautotimer()
{
  // Clean up after yourself!
}

const char *cPluginXxvautotimer::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return NULL;
}

bool cPluginXxvautotimer::ProcessArgs(int argc, char *argv[])
{
  // Implement command line argument processing here if applicable.
  return true;
}

bool cPluginXxvautotimer::Initialize(void)
{
  // Initialize any background activities the plugin shall perform.
  RegisterI18n(Phrases);
  return true;
}

bool cPluginXxvautotimer::Start(void)
{
  // Start any background activities the plugin shall perform.
  return true;
}

void cPluginXxvautotimer::Stop(void)
{
  // Stop any background activities the plugin shall perform.
}

void cPluginXxvautotimer::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

cOsdObject *cPluginXxvautotimer::MainMenuAction(void)
{
  // Perform the action when selected from the main VDR menu.
  return new cXxvAutotimerMenu;
}

cMenuSetupPage *cPluginXxvautotimer::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return new cXxvAutotimerSetupPage;
}

bool cPluginXxvautotimer::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return autotimerSetup.SetupParse(Name, Value);

}

//holds setup configuration
cXxvAutotimerSetup  autotimerSetup;

VDRPLUGINCREATOR(cPluginXxvautotimer); // Don't touch this!
